import {
  select,
  json,
  tsv,
  geoPath,//data path to svg path
  geoEquirectangular,
  //geoMercator,
  zoom,
  event,
  csv
} from 'd3';



import { feature } from 'topojson';//convert topojson to geojson

export const loadAndProcessData=()=>


  Promise.all([
    //tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
    //csv('https://vizhub.com/MukundKhandelwal/datasets/zero_append_part1.csv'),

    csv('https://vizhub.com/MukundKhandelwal/datasets/modified.csv'),  
    json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')//from world atlas
  ]).then(([tsvData, topoJSONdata]) => {

    const rowById = tsvData.reduce((accumulator, d) => {
      accumulator[d.iso_n3] = d;
      return accumulator;
    }, {});


    const Eco = {}; // economic status of the country
    tsvData.forEach(d => {
      Eco[d.iso_n3] = d.economy;
    });

  /*function ecoadd(a,b) { return a + '' + b };  
  function detail (d) {
  return countryName[d.id]+'\n'+Eco[d.id] };.*/


    const pb = {}; // primary balance of the country
    tsvData.forEach(d => {
      pb[d.iso_n3] = d.primary_balance;
    });

    const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

    countries.features.forEach(d=>{
      Object.assign (d.properties,rowById[d.id]);
    });
    
    return countries
    
  });